package name.panitz.util;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.Consumer;
import java.util.Comparator;

import java.util.NoSuchElementException;

public sealed interface LL<E> permits LL.Nil, LL.Cons{

  record Nil<E>() implements LL<E>{
    @Override public String toString(){return "[]";}
  }

  record Cons<E>(E hd,LL<E> tl) implements LL<E>{
    @Override public String toString(){
      return show(true,new StringBuffer("["));
    } 
  }

  default boolean isEmpty(){return this instanceof Nil;}

  default E head(){
    if (this instanceof Cons<E> c) return c.hd();
    throw new NoSuchElementException("head on empty list");
  }

  default LL<E> tail(){
    if (this instanceof Cons<E> c) return c.tl();
    throw new NoSuchElementException("tail on empty list");
  }

  @SuppressWarnings("rawtypes")
  final LL nil = new Nil<>();
  @SuppressWarnings("unchecked")
  static <E>LL<E> nil(){return nil;}

  static <E>LL<E> cons(E hd,LL<E> tl){return new Cons<>(hd,tl);}

  @SafeVarargs
  static <E>LL<E> of(E...es){
    LL<E> r = nil();
    for (int i=es.length-1;i>=0;i--) r = cons(es[i],r);
    return r; 
  }

  default String show(boolean first,StringBuffer result){
    if (isEmpty()) {
      result.append("]");
      return result.toString();
    }
    if (!first)result.append(", ");
    result.append(head());
    return tail().show(false,result);
  }

  //Unter Annahme dass xs aufsteigend sortiert istm, schreiben Sie eine
  //binäre Suche
  static int binSearch(int x,int[] xs){
    var low = 0;
    var up  = xs.length-1;
    while (low<=up){
      // TODO
    }
    return -1;
  }
  

  //rekursiv ist die Länge der Liste zu berechnen
  default int length(){
    //TODO
    return 0;
  }
  //iterativ ist die Länge der Liste zu berechnen
  default int lengthIt(){
    var r = 0;
    //TODO
    return r;
  }
  //rekursiv das letzte Listenelement
  default E last(){
    //TODO
    return null;
  }

  //rekursiv die Liste mit this und dann that Elementen
  default LL<E> append(LL<E> that){
    //TODO
    return that;
  }
  //rekursiv die Liste ohne die ersten i Elementen
  default LL<E> drop(int i){
    //TODO
    return this;
  }
  //rekursiv die Liste bestehend aus den ersten i Elementen
  default LL<E> take(int i){
    //TODO
    return nil();
  }
  //die Teilliste von index from mit länge length
  default LL<E> sublist(int from, int length) {
    //TODO
    return this;
  }


}
